#pragma once

#include "vm.hpp"

namespace sliger::rpc::vm_provider {
class VmProvider {
public:
    VmProvider() { }

    auto load_and_run(std::vector<uint32_t> instructions) -> void;
    auto flame_graph_json() -> std::optional<std::string>;
    auto code_coverage_json() -> std::optional<std::string>;

private:
    std::optional<VM> vm;
};

}
